# -*- coding: UTF-8 -*-
#####################################
# CSFD Lite by origin from mik9
#####################################
PLUGIN_VERSION = "1.3"

############## @TODOs
# - lokalizacia cz, sk, en
# - redesign
############## @TODOs

#from twisted.web.client import downloadPage, reactor
import requests
import traceback
import re
from random import *
import sys
from os import path, access, R_OK, remove, listdir
import time
import requests

try:
	from urllib import quote, unquote
	from urllib2 import build_opener, HTTPRedirectHandler
except:
	from urllib.request import build_opener, HTTPRedirectHandler
	from urllib.parse import quote, unquote
	

def dwnpage(a, b):
	with open(b, 'wb') as f:
		f.write( requests.get( a, headers={'User-agent': 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:56.0) Gecko/20100101 Firefox/56.0'} ).text.encode('utf-8') )

#	return downloadPage(a.encode('utf-8'), b) if sys.version_info[0] == 3 else downloadPage(a, b)

def toStr(a):
	try:
		if sys.version_info >= (3, 0, 0):
			if isinstance(a, str):
				return a
			if isinstance(a, bytes):
				return str(a, 'utf8')
			return str(a)
		if isinstance(a, basestring):
			if isinstance(a, unicode):
				return a.encode('utf-8')
			return a
		return str(a)
	except:
		print("[CSFDLite] toStr ERROR=%s"%traceback.format_exc())
	return "xxx"

def norm(text):
	#exp = toStr(text)
	exp = text
	try:
		if sys.version_info >= (3, 0, 0):
			import unicodedata
			exp = ''.join((c for c in unicodedata.normalize('NFD', exp) 
										if unicodedata.category(c) != 'Mn'))
		else:
			if isinstance(exp, str):
				exp = exp.decode('utf-8')
			import unicodedata
			exp = ''.join((c for c in unicodedata.normalize('NFD', exp) 
										if unicodedata.category(c) != 'Mn')).encode('utf-8')
	except:
		pass
	return exp


class CSFDLite():
	#def __init__(self, session, eventName='', callbackNeeded=False, EPG='', sourceEPG=False, DVBchannel='', *args, **kwargs):
	#def __init__(self, session, eventName, callbackNeeded=False, save=False, savepath=None, localpath=None):
	#def __init__(self, session, eventName, predanypopis='', args=None):
	#def __init__(self, session, eventName='', callbackNeeded=False, predanypopis='',sourceEPG=False, DVBchannel='', *args, **kwargs):
	def __init__(self, eventName, predanypopis='', args=None):
		self.omezenikomentaru = 500000

		self.eventName = eventName
		self.predanypopis = predanypopis
		self.commentsSort = 1
		self.getCSFD()

	def najdi(self, retezec, celytext):
		maska = re.compile(retezec, re.DOTALL)
		vysledek = maska.findall(celytext)
		vysledek = vysledek[0] if vysledek else ""
		return vysledek

	def hledejVse(self, retezec, celytext):
		maska = re.compile(retezec, re.DOTALL)
		vysledky = maska.findall(celytext)
		return vysledky

	def odstraneniTagu(self, upravovanytext):
		self.htmltags = re.compile('<.*?>')
		upravovanytext = self.htmltags.sub('', upravovanytext)
		upravovanytext = upravovanytext.replace('&amp;', '&').replace('&nbsp;', ' ')
		return upravovanytext

	def rimskeArabske(self, vstupnirimska):
		definicecislic = {'I':1, 'V':5, 'X':10, 'L':50, 'C':100, 'D':500, 'M':1000}
		rimska = ""
		for rznak in vstupnirimska:
			if rznak in "IVXLCDM":
				rimska+= rznak
		arabska = 0
		for iii, ccc in enumerate(rimska):
			if (iii+1) == len(rimska) or definicecislic[ccc] >= definicecislic[rimska[iii+1]]:
				arabska += definicecislic[ccc]
			else:
				arabska -= definicecislic[ccc]
		if arabska == 0:
			return ""
		else:
			return str(arabska)

	def rozlozeniNazvu(self, upravovanytext):
		zbytecnosti = [" -HD", " -W", " -ST", " -AD"]
		for zbytecnost in zbytecnosti:
			upravovanytext = upravovanytext.replace(zbytecnost, '')
		serialy = self.najdi('\s+([IVX]{0,7}\.?\s?\([0-9]?[0-9]?[0-9][,-]?\s?[0-9]?[0-9]?[0-9]?\))', upravovanytext)
		casti = self.najdi('\s+(\(?[0-9]?[0-9]?[0-9]/[0-9]?[0-9]?[0-9]\)?)(?![0-9])', upravovanytext)
		rimska_na_konci = self.najdi('\s+([IVX]{1,5}\.?)\s*$', upravovanytext)
		arabska_na_konci = self.najdi('\s+([0-9]?[0-9]?[0-9])\s*$', upravovanytext)
		kompletnazev = upravovanytext.replace(serialy, '').replace(" "+casti, ' ').replace(" "+rimska_na_konci, ' ').replace(" "+arabska_na_konci, ' ')
		rimska_na_konci = rimska_na_konci.replace(".","")
		rozlozenynazev = re.split('[:,;]', kompletnazev)
		nazev1 = rozlozenynazev[0].rstrip(' ')
		nazev2 = ""
		if len(rozlozenynazev) > 1:
			nazev2 = rozlozenynazev[1].lstrip(' ').rstrip(' ')
		bserial = False
		if serialy:
			print("X_Serialy: %s" % serialy)
			bserial = True
			serie = self.najdi('([IVX]{1,5})', serialy)
			if serie:
				kompletnazev+= "S" + self.rimskeArabske(serie).zfill(2)
			epizoda = self.najdi('\(([0-9]?[0-9]?[0-9])', serialy)
			kompletnazev+= "E" + epizoda.zfill(2)
		elif casti:
			print("X_Casti: %s" % casti)
			bserial = True
			epizoda = self.najdi('([0-9]?[0-9]?[0-9])/', casti)
			kompletnazev+= "E" + epizoda.zfill(2)
		elif rimska_na_konci:
			print("X_RNK: %s" % rimska_na_konci)
			bserial = True
			kompletnazev+= "série%20" + self.rimskeArabske(rimska_na_konci)
	
		serialy = self.najdi('\s+([IVX]{0,7}\.?\s?\([0-9]?[0-9]?[0-9][,-]?\s?[0-9]?[0-9]?[0-9]?\))', nazev1)
		casti = self.najdi('\s+(\(?[0-9]?[0-9]?[0-9]/[0-9]?[0-9]?[0-9]\)?)(?![0-9])', nazev1)
		rimska_na_konci = self.najdi('([IVX]{1,5}\.?)\s*$', nazev1)
		arabska_na_konci = self.najdi('([0-9]?[0-9]?[0-9])\s*$', nazev1)
		nazev1 = nazev1.replace(serialy, '').replace(" "+casti, ' ').replace(" "+rimska_na_konci, ' ').replace(" "+arabska_na_konci, ' ')
	
		serialy = self.najdi('\s+([IVX]{0,7}\.?\s?\([0-9]?[0-9]?[0-9][,-]?\s?[0-9]?[0-9]?[0-9]?\))', nazev2)
		casti = self.najdi('\s+(\(?[0-9]?[0-9]?[0-9]/[0-9]?[0-9]?[0-9]\)?)(?![0-9])', nazev2)
		rimska_na_konci = self.najdi('([IVX]{1,5}\.?)\s*$', nazev2)
		arabska_na_konci = self.najdi('([0-9]?[0-9]?[0-9])\s*$', nazev2)
		nazev2 = nazev2.replace(serialy, '').replace(" "+casti, ' ').replace(" "+rimska_na_konci, ' ').replace(" "+arabska_na_konci, ' ')
	
		return kompletnazev, bserial, nazev1, nazev2  

	def odstraneniInterpunkce(self, upravovanytext):
		interpunkce = ',<.>/?;:"[{]}`~!@#$%^&*()-_=+|'
		for znak in interpunkce:
			upravovanytext = upravovanytext.replace(znak, ' ')
		upravovanytext = upravovanytext.replace('   ', ' ').replace('  ', ' ')
		return upravovanytext

	def malaPismena(self, upravovanytext):
		return toStr(upravovanytext).lower()

	def adresaPredPresmerovanim(self, adresa):
		opener = build_opener(HTTPRedirectHandler)
		request = opener.open(adresa)
		return request.url

	def fetchFailed(self, kde):
		print("[CSFDLite] fetch failed " + kde)

	def getCSFD(self):
		self.popisEPG = self.predanypopis

		if self.popisEPG:
			self.rokEPG = self.najdi('\([1-2][0-9]{3}\)', self.popisEPG).replace("(","").replace(")","")
			if self.rokEPG == '':
				self.rokEPG = self.najdi('[1-2][0-9]{3}', self.popisEPG)
		else:
			self.rokEPG = ''

		if self.eventName != "":
			self.nazeveventuproskin = toStr(self.eventName)
#			try:
#				self.eventName = quote(self.eventName)
#			except:
#				self.eventName = quote(self.eventName.decode('utf-8').encode('ascii','ignore'))


			self.nazeveventu = self.eventName
			print('///////////////BEFORE nazeveventu(rok=%s)=%s'%(self.rokEPG, self.nazeveventu))
			jineznaky = list(set(self.hledejVse('(%[0-9A-F][0-9A-F])', self.nazeveventu)))
			for jinyznak in jineznaky:
				desitkove = int(jinyznak[1:3], 16)
				if desitkove > 31 and desitkove < 128:
					self.nazeveventu = self.nazeveventu.replace(jinyznak, chr(desitkove)) 
				elif desitkove > 127:
					self.nazeveventu = self.nazeveventu.replace(jinyznak, jinyznak.lower())
			self.nazeveventu = self.nazeveventu.replace('%', '\\x')
			print('///////////////AFTER nazeveventu=%s'%self.nazeveventu)

			self.celejmeno, self.je_serial, self.jmeno1, self.jmeno2 = self.rozlozeniNazvu(self.nazeveventu)
			print( "Cele meno: %s, Je serial: %s, Meno1: %s, Meno2: %s\n" % (self.celejmeno, str(self.je_serial), self.jmeno1, self.jmeno2) )
			return
			dotaz1 = self.celejmeno
			if not self.je_serial:
				dotaz1+= "%20" + self.rokEPG
			print('///////////////AFTER dotaz1=%s'%dotaz1)
			
			dotaz1 = dotaz1.replace(" ", "%20").replace('\\x', "%")
			self.jmeno1 = self.jmeno1.replace(" ", "%20").replace('\\x', "%")
			self.jmeno2 = self.jmeno2.replace(" ", "%20").replace('\\x', "%")

			print("Hledání v CSFD pro: %s" % (self.nazeveventuproskin))
			localfile = "/tmp/CSFDquery.html"
			fetchurl = "https://www.csfd.cz/hledat/?q=" + dotaz1
			self.puvodniurl = fetchurl
			print("[CSFDLite] Downloading Query " + fetchurl + " to " + localfile)
			dwnpage(fetchurl,localfile)
			self.CSFDquery('')
#			with open(localfile, 'wb') as f:
#				f.write( requests.get( fetchurl, stream=True ).raw.read() )
#				self.CSFDquery('')

	def CSFDquery(self, string):
		print("[CSFDquery]")
		print("Stahování z CSFD dokončeno pro %s" % (self.nazeveventuproskin))
		self.inhtml = (open("/tmp/CSFDquery.html", "r").read())
		self.resultlist = []
		self.unikatni = False

		if '<h1 itemprop="name">' in self.inhtml:
			odkaz = self.najdi('https://www.csfd.cz/film/(.*?)/', self.inhtml)
			nazevfilmu = self.najdi('<h1 itemprop=\"name\">(.*?)<', self.inhtml)
			nazevfilmu = nazevfilmu.replace("\t","").replace("\n","")
			self.resultlist = [(nazevfilmu, odkaz)]
		else:
			print("[CSFDLite] ziskavani seznamu")
			self.resultlist = []
			seznamfilmu = self.najdi('<h2>Filmy(.*?)<h2>Seri', self.inhtml)
			seznamserialu = self.najdi('<h2>Seri(.*?)</section>', self.inhtml)
			if self.je_serial:
				seznamcely = seznamserialu + seznamfilmu
			else:
				seznamcely = seznamfilmu + seznamserialu
			for odkaz, filmnazev, filminfo in self.hledejVse('<h3.*?<a href="/film/(.*?)".*?"film-title-name">(.*?)</a>(.*?)</h3>', seznamcely):
				hlavninazev = filmnazev
				celynazev = hlavninazev
				rok = self.najdi('<span class="info">\(([0-9]{4})', filminfo)
				typnazev = self.najdi('<span class="info">.*?<span class="info">\((.*[a-z])\)', filminfo)
				if rok != "":
					celynazev += ' (' + rok + ')'
				if typnazev != "":
					celynazev += ' (' + typnazev + ')'
				self.resultlist += [(celynazev, odkaz, hlavninazev, rok)]
				
			print("Hledání v CSFD pro: %s" % (self.nazeveventuproskin) )
			localfile = "/tmp/CSFDquery_dotaz2.html"
			fetchurl = "https://www.csfd.cz/hledat/?q=" + self.jmeno1
			self.puvodniurl = fetchurl
			print("[CSFDLite] Downloading Query " + fetchurl + " to " + localfile)
			dwnpage(fetchurl,localfile)
			self.CSFDquery_dotaz2('')

	def CSFDquery_dotaz2(self, string):			
		print("[CSFDquery_dotaz2]")
		print("Stahování z CSFD dokončeno pro %s" % (self.nazeveventuproskin))
		self.inhtml = (open("/tmp/CSFDquery_dotaz2.html", "r").read())

		if '<h1 itemprop="name">' in self.inhtml:
			odkaz = self.najdi('https://www.csfd.cz/film/(.*?)/', self.inhtml)
			nazevfilmu = self.najdi('<h1 itemprop=\"name\">(.*?)<', self.inhtml)
			nazevfilmu = nazevfilmu.replace("\t","").replace("\n","")
			self.resultlist = [(nazevfilmu, odkaz)]
		elif "SFD.cz </title>" in self.inhtml:
			print("[CSFDLite] ziskavani seznamu 2")
			for odkaz, filmnazev, filminfo in self.hledejVse('<h3.*?<a href="/film/(.*?)".*?"film-title-name">(.*?)</a>(.*?)</h3>', self.inhtml):
				hlavninazev = filmnazev
				celynazev = hlavninazev
				rok = self.najdi('<span class="info">\(([0-9]{4})', filminfo)
				typnazev = self.najdi('<span class="info">.*?<span class="info">\((.*[a-z])\)', filminfo)
				if rok != "":
					celynazev += ' (' + rok + ')'
				if typnazev != "":
					celynazev += ' (' + typnazev + ')'
				self.resultlist += [(celynazev, odkaz, hlavninazev, rok)]

			if self.jmeno2 != "" and self.jmeno2 != " ":
				print("Hledání v CSFD pro: %s" % (self.nazeveventuproskin))
				localfile = "/tmp/CSFDquery_dotaz3.html"
				fetchurl = "https://www.csfd.cz/hledat/?q=" + self.jmeno2
				self.puvodniurl = fetchurl
				print("[CSFDLite] Downloading Query " + fetchurl + " to " + localfile)
				dwnpage(fetchurl,localfile)
				self.CSFDquery_dotaz3('') # self.CSFDquery_dotaz2() on fail
			else:
				self.projitSeznam()
		else:
			print("Dotaz na CSFD nebyl úspěšný")

	def CSFDquery_dotaz3(self, string):			
		print("[CSFDquery_dotaz3]")
		print("Stahování z CSFD dokončeno pro %s" % (self.nazeveventuproskin))
		self.inhtml = (open("/tmp/CSFDquery_dotaz3.html", "r").read())

		if '<h1 itemprop="name">' in self.inhtml:
			odkaz = self.najdi('https://www.csfd.cz/film/(.*?)/', self.inhtml)
			nazevfilmu = self.najdi('<h1 itemprop=\"name\">(.*?)<', self.inhtml)
			nazevfilmu = nazevfilmu.replace("\t","").replace("\n","")
			self.resultlist = [(nazevfilmu, odkaz)]
		elif "SFD.cz </title>" in self.inhtml:
			print("[CSFDLite] ziskavani seznamu 3")
			for odkaz, filmnazev, filminfo in self.hledejVse('<h3.*?<a href="/film/(.*?)".*?"film-title-name">(.*?)</a>(.*?)</h3>', self.inhtml):
				hlavninazev = filmnazev
				celynazev = hlavninazev
				rok = self.najdi('<span class="info">\(([0-9]{4})', filminfo)
				typnazev = self.najdi('<span class="info">.*?<span class="info">\((.*[a-z])\)', filminfo)
				if rok != "":
					celynazev += ' (' + rok + ')'
				if typnazev != "":
					celynazev += ' (' + typnazev + ')'
				self.resultlist += [(celynazev, odkaz, hlavninazev, rok)]
			self.projitSeznam()
		else:
			print("Dotaz na CSFD nebyl úspěšný")

	def projitSeznam(self):	
		print("[CSFDLite] prochazim seznam")
		try:
			self.resultlist = sorted(set(self.resultlist), key=self.resultlist.index)   # odstraneni duplicit v seznamu
			shoda = []
			for nazevinfo, odkaz, nazevfilmu, rok in self.resultlist:
				if norm(nazevfilmu) == norm(unquote(self.eventName)):
					shoda += [(nazevinfo, odkaz, rok)]
				elif norm(unquote(self.eventName)).startswith(norm(nazevfilmu)):
					shoda += [(nazevinfo, odkaz, rok)]
			if len(shoda) == 1:
				self.nazevkomplet, self.link, v3 = shoda[0]
				self.unikatni = True
			elif len(shoda) > 1:
				for nazevinfo, odkaz, rok in shoda:
					if self.rokEPG == rok and not self.unikatni:
						self.nazevkomplet, self.link, v3 = self.odstraneniTagu(nazevinfo), odkaz, rok
						self.unikatni = True
						print("Unikat: %s, odkaz: %s, rok: %s" % (self.nazevkomplet, self.link, v3))
#			self.resultlist = [(v1, v2) for v1, v2, v3, v4 in self.resultlist]

			if self.resultlist:
#				self.resultlist = [(self.odstraneniTagu(nazevinfo), odkaz) for nazevinfo, odkaz in self.resultlist]
				
				print( "Vysledok:")
				for result in self.resultlist:
					print( "celynazev: %s, odkaz: %s, hlavninazev: %s, rok: %s" % result )
			else:
				print("Nenalezena informace v CSFD pro %s" % (self.nazeveventuproskin))
		except:
			print("/////////// ERROR %s"%traceback.format_exc())

	def CSFDquery2(self, string):
		print("Stahování informace o filmu dokončeno pro:  %s" % (self.nazevkomplet))
		self.inhtml = (open("/tmp/CSFDquery2.html", "r").read())
		if 'DOCTYPE html' in self.inhtml:
			self.CSFDparse()
		else:
			print("Problem pri načítání: %s" % (self.link))

#event = "Rosemary a Thymeová"
#epg = '''[krimi, drama] Zločiny v zahradách Strom smrti (S1E6) (2003) [VB]
#Krátký popis dílu Strom smrti Laura a Rosemary mají tentokrát na starost úpravu zanedbaného hřbitova. Do práce se ale pustí pořádně teprve tehdy, když zde najdou mrtvolu... Popis dílu Strom smrti Rosemary Boxerová a Laura Thymeová mají práci na značně zarostlém a zanedbaném hřbitově. Na rekonstrukci mají velmi málo času, protože musí být vše připraveno na chystané slavnosti. Franklin Danvers má zájem o Brockettovu farmu, kterou vlastní po smrti otce Marie Suttonová se svým starším bratrem Malcolmem, který je však několik let pohřešovaný. Nyní uplynula zákonná lhůta a Marie může farmu prodat. Danversovi však konkuruje firma na výrobu léků Knussen, která má o objekt také zájem. Firma... má večer veřejnou schůzi o plánech s farmou, na které se náhle objeví Malcolm, Mariin bratr. Pohádá s e s Danversem a řekne, že se farma prodávat nebude. Poté vyslechnou Laura s Rosemary jeho telefonní hovor, kdy si s někým smlouvá schůzku na hřbitově. Ráno ho najdou na hřbitově zastřeleného šípem, luk ale nemůže nikdo najít... B. Farnham F. Kendal P. Ferrisová M. Cochrane a další.'''

event = "Monk IV (15)"
epg =  '''[Mag] Pán Monk a pani Monková (E6)
#Natalie stretne v bistre ženu, ktorá vyzerá ako Trudy. Dokonca sa za Trudy aj vydáva. Natalie ju vyfotí, aby mala dôkaz, ale žena jej film zoberie. Keď sa to dozvie Monk, ktorému sa v poslednej dobe darilo zdravotne lepšie, takmer sa zrúti. Čoskoro ale príde na to, že nejde o Trudy. Vydáva sa za ňu herečka, ktorá pracuje pre šéfa odborov prístavných robotníkov. S jej pomocou chce Jack Bollinger získať staré dokumenty, ktoré patrili Trudy, aby sa nedostali na verejnosť a nekompromitovali ho. Hrají: Tony Shalhoub, Traylor Howardová Tony Shalhoub Traylor Howardová.'''

event = 'Neobjasněná akta NASA: Red Storm Rising III (7)'
epg = '''[Dokumentární] (NASA's Unexplained Files: Mystery Of The Invisible Planet) Záhada neviditelné planety (S3E7/0) (2014) [Spojené státy]
Přiblížíme vám přímé zkušenosti astronautů NASA, kteří byli svědky záhad, nemožných úkazů i naprostých podivností. Kamery NASA totiž zachytily nesčetné tajemné předměty. V tomto speciálu vám prostřednictvím originálních záběrů a převratných rozhovorů s astronauty a vědci ukážeme deset největších nevysvětlených setkání. Lze tyto úkazy vysvětlit pomocí vědy a detektivních metod? Nebo kamery NASA natočily první stopy mimozemského života? Christopher McKay John D. Rummel.'''

lite = CSFDLite( event, epg )
#reactor.run()
